/* 
	Costache Alexandru-Marian
	335CA
	TicTacToe - Proiect PM
 */


#include <avr/io.h>
#include <util/delay.h>
#include "../mpu6050/mpu6050.c"
#include "../i2chw/i2cmaster.h"
#include "../nokia5110.h"
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <math.h>


double datax;
double datay;
double dataz;

void acc_data() {
	
	double axg, ayg, azg, gxds, gyds, gzds;
	
	axg = ayg = azg = 0;
	gxds = gyds = gzds = 0;
	
	mpu6050_getConvData(&axg, &ayg, &azg, &gxds, &gyds, &gzds);
	
	datax = axg;
	datay = ayg;
	dataz = azg;
	
}
void table_init(){
	int i;
    for(i = 0; i < 48; i++){
    	nokia_lcd_set_pixel(16,i,1);
    	nokia_lcd_set_pixel(32,i,1);
    	nokia_lcd_set_pixel(i,16,1);
    	nokia_lcd_set_pixel(i,32,1);
    }
}

void clear_text(){
	int i,j;
	for(i=49; i<84; i++){
		for(j=2; j<36; j++){
			nokia_lcd_set_pixel(i,j,0);
		}
	}
}
int somebody_won(int v[9]){

	int i;
	for(i = 0; i<3; i++){
		if( v[i * 3] == v[i * 3 + 1] && v[i * 3 + 1] == v[i * 3 + 2]){
			if(v[i * 3]!= 0)
				return 1;
		}
		if( v[i] == v[i + 3] && v[i + 3] == v[i + 6]){
			if(v[i] != 0)
				return 1;
		}
	}
	if((v[0] == v[4] && v[4] == v[8]) || (v[2] == v[4] && v[4] == v[6])){
		if(v[4] != 0)
			return 1;
	}
	return 0;
}

int is_draw(int v[9]){
	int i;
	for(i = 0; i < 9; i++){
		if(v[i] == 0){
			return 0;
		}
	}
	return 1;
}
int main(void)
{
	DDRD &= ~(1 << PD0);
    PORTD |= (1 << PD0);
    nokia_lcd_init();
    mpu6050_init();
    nokia_lcd_clear();
    int i;
    int x = 2;
    int y = 15;
    int pos = 0;
    int player = 0;
    int v[9] = {0,0,0,0,0,0,0,0,0};
    table_init();
    nokia_lcd_set_cursor(54,18);
    while(1){
    	acc_data();
    	for(i = 0; i < 12; i++){
    		nokia_lcd_set_pixel(x+i,y,1);
    	}
    	nokia_lcd_render();
    	_delay_ms(500);
    	acc_data();	
    	for(i=0; i<12; i++){
    		nokia_lcd_set_pixel(x+i,y,0);

    	}
    	nokia_lcd_render();
    	_delay_ms(500);

    	if(datay > 0.3){
    		if(x + 16 <= 34){
    			x +=16;
    		}
    	}
    	if(datay < -0.3){
    		if(x - 16 >= 2){
    			x -=16;
    		}
    	}
    	if(dataz > 0.3){
    		if(y - 16 >= 15){
    			y -=16;
    		}
    	}
    	if(dataz < -0.3){    		
    		if(y + 16 <= 47){
    			y +=16;
    		}
    	}
    	pos = ((x - 2) % 15) + 3 * (y % 15);
    	clear_text();
    	nokia_lcd_set_cursor(49,2);
    	if(player == 0)
    		nokia_lcd_write_string("First",1);
    	else
    		nokia_lcd_write_string("Second",1);
    	nokia_lcd_set_cursor(49,12);
    	nokia_lcd_write_string("player",1);
    	nokia_lcd_set_cursor(49,22);
    	nokia_lcd_write_string("turn",1);
     	
    	if((PIND & (1 << PD0)) == 0) {
    		if(v[pos] == 0){
    			nokia_lcd_set_cursor(x+1, y-14);
    			if(player == 0){
    				nokia_lcd_write_char(88, 2);
    			}
    			else{
    				nokia_lcd_write_char(48, 2);
    			}
    			v[pos] = player + 1;
    			player = (player + 1) % 2;
    		}
		}
		if(somebody_won(v) == 1){
			clear_text();
			nokia_lcd_set_cursor(49,2);
			if(player == 0)
    			nokia_lcd_write_string("Second",1);
    		else
	    		nokia_lcd_write_string("First",1);
			nokia_lcd_set_cursor(49,12);
	    	nokia_lcd_write_string("player",1);
	    	nokia_lcd_set_cursor(60,22);
	    	nokia_lcd_write_string("WIN",1);
	    	break;
		}
		if(is_draw(v) == 1){
			clear_text();
			nokia_lcd_set_cursor(60,22);
			nokia_lcd_write_string("TIE",1);
			break;
		}
	
    }
    nokia_lcd_render();
	for(;;){
		_delay_ms(500);
	}
   
}
